#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <math.h>

#include "vector.h"
#include "matrix.h"
#include "pixel.h"
#include "list.h"
#include "camera.h"
#include "model.h"

// prototypes
int main(int argc, char *argv[]);

int main(int argc, char *argv[])
{
	model_t		*model=NULL;
	FILE		*model_file=NULL;

  if(argc != 2) {
    fprintf(stderr,"Usage: %s <model_file>\n",argv[0]);
    exit(1);
  }

  // open model file
  if((model_file = fopen(argv[1],"r")) == NULL) {
     printf("Error opening input file: %s\n",argv[1]);
     return;
  }

  // create model
  model = model_init(model_file);

  // close file
  fclose(model_file);

  // verify that we have the model
  model_print(model,stdout);

  // free up memeory
  model_del(model);

  return(0);
}
