#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <math.h>

#include "pixel.h"

// compute componentwise sum of two rgb values
void pix_sum(drgb_t p1,drgb_t p2,drgb_t p3)
{
	int	i;

  for(i=0;i<3;i++) p3[i] = p1[i] + p2[i];
}

// compute componentwise product of two rgb values
void pix_prod(drgb_t p1,drgb_t p2,drgb_t  p3)
{
	int	i;

  for(i=0;i<3;i++) p3[i] = p1[i] * p2[i];
}

// compute p2 = s * p1 where s is a scalar
void pix_scale(double s,drgb_t p1,drgb_t p2)
{
	int	i;

  for(i=0;i<3;i++) p2[i] = s * p1[i];
}

// compute componentwise sum of two rgb values
void pix_copy(drgb_t p1,drgb_t  p2)
{
  memcpy(p2,p1,sizeof(drgb_t));
}

// read values into pixel p1 and return the number of values read
int pix_read(FILE *in,drgb_t p1)
{
	int	i;
	int	c=0;	// count

  for(i=0;i<3;i++) c += fscanf(in,"%lf",&p1[i]);

  return(c);
}

// print contents of pixel using %8.3lf format, with \n after last element
void pix_print(FILE *out,char *label,drgb_t pix)
{
	int	i;

  fprintf(out,"%s",label);
  for(i=0;i<3;i++)
    pix[i] < 0.0 ? fprintf(out,"%5.1lf",pix[i]) : fprintf(out,"%2.0lf",pix[i]); 
  fprintf(out,"\n");
}

// return 1 if pixel is non-zero
int pix_nonzero(drgb_t pix)
{
	int	i;
	double	precision=0.0000001;

  for(i=0;i<3;i++) if(fabs(pix[i]) > precision) return(1);

  return(0);
}
