// Two pixel value structures are used:
// Computations are done in the double precision domain
// where 0.0 means black and 1.0 means maximum intensity
// The raytracing algorithm can DEFINITELY produce
// pixel values that exceed 1.0 scale and then clamp
// them before assigning them to irgb_types

typedef double drgb_t[3];

// The .ppm file requires the usual r-g-b values in the
// range 0-255.  This structure maps one of them.

typedef unsigned char irgb_t[3];

void	pix_sum(drgb_t p1,drgb_t p2,drgb_t p3);
void	pix_prod(drgb_t p1,drgb_t p2,drgb_t  p3);
void	pix_scale(double s,drgb_t p1,drgb_t p2);
void	pix_copy(drgb_t p1,drgb_t  p2);
int	pix_read(FILE *in,drgb_t p1);
void	pix_print(FILE *out,char *label,drgb_t pix);
int	pix_nonzero(drgb_t pix);
